diff -Nur samba-3.0.4.orig/source/param/loadparm.c samba-3.0.4.dmro/source/param/loadparm.c
--- samba-3.0.4.orig/source/param/loadparm.c	2004-04-20 22:42:54.000000000 +0200
+++ samba-3.0.4.dmro/source/param/loadparm.c	2004-07-30 10:35:14.776680000 +0200
@@ -10,6 +10,11 @@
    Copyright (C) Stefan (metze) Metzmacher 2002
    Copyright (C) Jim McDonough <jmcd@us.ibm.com> 2003
    
+   07/14/2004 added "dos mask readonly" support
+              Markus Greger      <Markus.Greger@izb-soft.de>
+              Thomas Maier       <Thomas.Maier@izb-soft.de>
+   
+
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
@@ -416,6 +421,7 @@
 	BOOL bAfs_Share;
 	BOOL bEASupport;
 	param_opt_struct *param_opt;
+	BOOL bDosMaskReadonly; /* "dos mask readonly" patch by Markus Greger, Thomas Maier  IZB SOFT 07/14/2004 */
 
 	char dummy[3];		/* for alignment */
 }
@@ -542,6 +548,9 @@
 	
 	NULL,			/* Parametric options */
 
+	/* "dos mask readonly" patch by Markus Greger, Thomas Maier  IZB SOFT 07/14/2004 */
+	False,          /* Dos Mask Readonly */
+
 	""			/* dummy */
 };
 
@@ -1138,6 +1147,8 @@
 	{"dos filemode", P_BOOL, P_LOCAL, &sDefault.bDosFilemode, NULL, NULL, FLAG_ADVANCED | FLAG_SHARE | FLAG_GLOBAL}, 
 	{"dos filetimes", P_BOOL, P_LOCAL, &sDefault.bDosFiletimes, NULL, NULL, FLAG_ADVANCED | FLAG_SHARE | FLAG_GLOBAL}, 
 	{"dos filetime resolution", P_BOOL, P_LOCAL, &sDefault.bDosFiletimeResolution, NULL, NULL, FLAG_ADVANCED | FLAG_SHARE | FLAG_GLOBAL}, 
+/* "dos mask readonly" patch by Markus Greger, Thomas Maier  IZB SOFT 07/14/2004 */
+	{"dos mask readonly", P_BOOL, P_LOCAL, &sDefault.bDosMaskReadonly, NULL, NULL, FLAG_ADVANCED | FLAG_SHARE | FLAG_GLOBAL},
 
 	{"fake directory create times", P_BOOL, P_LOCAL, &sDefault.bFakeDirCreateTimes, NULL, NULL, FLAG_ADVANCED | FLAG_SHARE | FLAG_GLOBAL}, 
 	{"panic action", P_STRING, P_GLOBAL, &Globals.szPanicAction, NULL, NULL, FLAG_ADVANCED}, 
@@ -1902,6 +1913,8 @@
 FN_GLOBAL_INTEGER(lp_name_cache_timeout, &Globals.name_cache_timeout)
 FN_GLOBAL_INTEGER(lp_client_signing, &Globals.client_signing)
 FN_GLOBAL_INTEGER(lp_server_signing, &Globals.server_signing)
+/* "dos mask readonly" patch by Markus Greger, Thomas Maier  IZB SOFT 07/14/2004 */
+FN_LOCAL_BOOL(lp_dos_mask_ro, bDosMaskReadonly)
 
 /* local prototypes */
 
diff -Nur samba-3.0.4.orig/source/smbd/dosmode.c samba-3.0.4.dmro/source/smbd/dosmode.c
--- samba-3.0.4.orig/source/smbd/dosmode.c	2004-04-04 09:37:31.000000000 +0200
+++ samba-3.0.4.dmro/source/smbd/dosmode.c	2004-07-30 10:35:36.475156000 +0200
@@ -3,6 +3,11 @@
    dos mode handling functions
    Copyright (C) Andrew Tridgell 1992-1998
    
+   07/14/2004 added "dos mask readonly" support
+              Markus Greger      <Markus.Greger@izb-soft.de>
+              Thomas Maier       <Thomas.Maier@izb-soft.de>
+   
+   
    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
@@ -148,6 +153,10 @@
 #endif
 #endif
 
+	/* "dos mask readonly" patch by Markus Greger, Thomas Maier  IZB SOFT 07/14/2004 */
+	if ( (result & aRONLY) && lp_dos_mask_ro(SNUM(conn)) )
+		result &= ~(aRONLY);
+
 	DEBUG(8,("dos_mode_from_sbuf returning "));
 
 	if (result & aHIDDEN) DEBUG(8, ("h"));
